module TB_pic16c5x;
   reg clk_q1;
   reg clk_q2;
   reg reset;
   wire [11:0] rom_data;
   reg [7:0]  pa_in, pb_in, pc_in;

   wire [7:0] pa_out, pb_out, pc_out, w_out, f_out, status_out, fsr_out;

   wire [10:0] rom_addr;


   reg [11:0]  rom [2047:0];

   
   assign rom_data = rom[rom_addr];
   
   pic16c5x pic(clk_q1,
	    clk_q2,
	    reset,
	    rom_data,  
	    pa_in, 
	    pb_in,  
	    pc_in, 
	    pa_out,
	    pb_out, 
	    pc_out, 
	    rom_addr,

	    w_out,
	    f_out,
	    status_out,
	    fsr_out);

   initial begin
      reset =0;
      pa_in=8'haa;
      pb_in=8'hbb;
      pc_in=8'hcc;
      #2 reset =1;
      #2 reset =0;
      pa_in = 8'h55;
      $readmemb("rom.dat", rom);
      /*
      $readmemh("rom_6.dat", rom);
      rom[2047] = 12'b1010_0000_0000;
      $display("rom:%b", rom[0]);
       */
      #56300
	pa_in = 8'hAA;
   end
   
   always begin
      #100 clk_q1=0; clk_q2=1;
      #100 clk_q1=1; clk_q2=0;
   end

   always @(posedge clk_q1 or posedge clk_q2) begin
      $display($time,,,"%d fsr:%b status:%b f_out:%h %b %h %b %d", clk_q1, fsr_out, status_out, f_out, pa_in, pb_out, rom_data, rom_addr);
   end
   
endmodule // TB_pic16c5x



