module TB_reg_top;

   reg clk_q3, clk_q4, reset;
   reg [4:0] fsel;
   reg 	     fwe, d;
   reg [7:0] alu_out, portA_in, portB_in, portC_in;
   reg 	     alu_c, 
	     alu_z, 
	     alu_dc,
	     c_write,
	     z_write,
	     
	     op_addwf,
	     op_andwf,
	     op_clrf,
	     op_clrw,
	     op_comf,
	     op_decf,
	     op_decfsz,
	     op_incf,
	     op_incfsz,
	     op_iorwf,
	     op_movf,
	     op_movwf,
	     op_rlf,
	     op_rrf,
	     op_subwf,
	     op_swapf,
	     op_xorwf,
	       
	     op_bcf,
	     op_bsf,
	     // op_btfsc,
	     // op_btfss,
	       
	     op_andlw,
	     op_iorlw,
	     op_movlw,
 	     op_retlw,
	     op_xorlw;
   wire [7:0] wout, fout, portA_out, portB_out, portC_out, fsr_out, status_out;

   reg_top u(clk_q3,
	     clk_q4,
	     reset,
	     fsel,
	     fwe,
	     d,
	     
	     alu_out,
	       
	     portA_in,
	     portB_in,
	     portC_in,
	     
	     alu_c,
	     alu_z,
	     alu_dc,

	     c_write,
	     z_write,
	       
	     op_addwf,
	     op_andwf,
	     op_clrf,
	     op_clrw,
	     op_comf,
	     op_decf,
	     op_decfsz,
	     op_incf,
	     op_incfsz,
	     op_iorwf,
	     op_movf,
	     op_movwf,
	     op_rlf,
	     op_rrf,
	     op_subwf,
	     op_swapf,
	     op_xorwf,
	       
	     op_bcf,
	     op_bsf,
	     //	op_btfsc,
	     //	op_btfss,
	       
	     op_andlw,
	     op_iorlw,
	     op_movlw,
 	     op_retlw,
	     op_xorlw,
	       
	       
	     wout,
	     fout,
	     portA_out,
	     portB_out,
	     portC_out,
	     fsr_out,
	     status_out
	     );

   initial begin
      reset = 0;
      #2 reset =1 ;
      #2 reset =0;
   end
   
   always begin
      #10 clk_q3=0; clk_q4=1;
      #10 clk_q3=1; clk_q4=0;
   end

   initial  begin
      @(negedge clk_q3)
      fsel <= 10;
      fwe <= 0;
      d <= 1;
      alu_out <= 1;
	       
      portA_in <= 8'b0000_0000;
      portB_in <= 8'b0000_0000;
      portC_in <= 8'b0000_0000;
      
      alu_c <= 1;
      alu_z <= 1;
      alu_dc <= 0;
      c_write <= 0;
      z_write <= 0;
      
      op_addwf <= 0;
      op_andwf <= 0;
      op_clrf <= 0;
      op_clrw <= 0;
      op_comf <= 0;
      op_decf <= 0;
      op_decfsz <= 0;
      op_incf <= 0;
      op_incfsz <= 0;
      op_iorwf <= 0;
      op_movf <= 0;
      op_movwf <= 0;
      op_rlf <= 0;
      op_rrf <= 0;
      op_subwf <=0;
      op_swapf <=0;
      op_xorwf <=0;
	       
      op_bcf <= 0;
      op_bsf <= 0;
      // op_btfsc,
      // op_btfss,
	       
      op_andlw <= 0;
      op_iorlw <= 0;
      op_movlw <= 1;
      op_retlw <= 0;
      op_xorlw <= 0;
      
      @(negedge clk_q3)

      fsel <= 10;
      fwe <= 1;
      d <= 1;
      alu_out <= 1;
	       
      portA_in <= 8'b0000_0000;
      portB_in <= 8'b0000_0000;
      portC_in <= 8'b0000_0000;
      
      alu_c <= 1;
      alu_z <= 1;
      alu_dc <= 0;
      c_write <= 0;
      z_write <= 0;
      
      op_addwf <= 0;
      op_andwf <= 0;
      op_clrf <= 0;
      op_clrw <= 0;
      op_comf <= 0;
      op_decf <= 0;
      op_decfsz <= 0;
      op_incf <= 0;
      op_incfsz <= 0;
      op_iorwf <= 0;
      op_movf <= 0;
      op_movwf <= 1;
      op_rlf <= 0;
      op_rrf <= 0;
      op_subwf <=0;
      op_swapf <=0;
      op_xorwf <=0;
	       
      op_bcf <= 0;
      op_bsf <= 0;
      // op_btfsc,
      // op_btfss,
	       
      op_andlw <= 0;
      op_iorlw <= 0;
      op_movlw <= 0;
      op_retlw <= 0;
      op_xorlw <= 0;
	
   end

endmodule // TB_reg_top
