/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */
module instruction_reg(clk, 
		       reset, 
		       fsr_rs,
		       call_inst,
		       goto_inst,
		       skip,
		       rom_data,
		       
		       inst,
		       k,
		       longk,
		       fsel,
		       d);
   input clk, reset;
   input call_inst, goto_inst;
   input skip;
   input [11:0] rom_data;
   input [4:0] 	fsr_rs;
   
   output [11:0] inst;
   output [7:0]  k;
   output [8:0]  longk;
   output [4:0]  fsel;
   output 	 d;
   
   reg [11:0] 	 inst_buf;

   always @(posedge clk or posedge reset) begin
      if( reset == 1'b1)
	inst_buf <= 12'b0000_0000_0000;
      else begin
	 if(/*call_inst == 1'b1 || goto_inst == 1'b1 ||*/ skip == 1'b1)
	   inst_buf <= 12'b0000_0000_0000;
	 else
	   inst_buf <= rom_data;
      end
   end

   assign inst = inst_buf;
   assign k  = inst_buf[7:0];
   assign longk = inst_buf[8:0];
   assign fsel = (inst_buf[4:0] === 4'b0000) ? fsr_rs:inst_buf[4:0];
   assign d = inst_buf[5];
endmodule // instruction_reg

	 

