/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */
module mux_alu_b(f,
		 k,
		 w,
		 op_clrf,
		 op_clrw,
		 op_decf,
		 op_decfsz,
		 op_incf,
		 op_incfsz,
		 op_movwf,
		 op_subwf,
		 
		 op_bcf,
		 op_bsf,
		 op_btfsc,
		 op_btfss,
	      
		 op_andlw,
		 op_iorlw,
		 op_movlw,
		 op_retlw,
		 op_xorlw,

		 alu_b
		 );
   input [7:0] f, k, w;
   input       op_clrf,
	       op_clrw,
	       op_decf,
	       op_decfsz,
	       op_incf,
	       op_incfsz,
	       op_movwf,
	       op_subwf,
	       op_bcf,
	       op_bsf,
	       op_btfsc,
	       op_btfss,
	       op_andlw,
	       op_iorlw,
	       op_movlw,
	       op_retlw,
	       op_xorlw;
   output [7:0] alu_b;

   assign alu_b = 
	  (op_movwf == 1 ||
	   op_clrw == 1 ||
	   op_clrf == 1 ||
	   op_subwf == 1 ||
	   op_iorlw == 1 ||
	   op_andlw == 1 ||
	   op_xorlw == 1) ? w:
	  (op_bcf == 1 ||
	   op_bsf == 1 ||
	   op_btfsc == 1 ||
	   op_btfss == 1 ||
	   op_retlw == 1 ||
	   op_movlw == 1) ? k:
	  (op_decf == 1 ||
	   op_incf == 1 ||
	   op_decfsz == 1 ||
	   op_incfsz == 1) ? 8'b0000_0001: f;
   
endmodule // mux_alu_b


