/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */

module mux_status_write(op_clrw,
			op_clrf,
			op_subwf,
			op_decf,
			       
			op_andwf,
			op_xorwf,
			op_addwf,
			op_iorwf,
			op_movf, 
			op_comf, 
			op_incf, 
			op_rrf,  
			op_rlf,  

			op_iorlw,
			op_andlw,
			op_xorlw,
			
			c_write, 
			z_write
			);
   
   input op_clrw,
	 op_clrf,
	 op_subwf,    
	 op_decf,     
			       
	 op_andwf,
	 op_xorwf,
	 op_addwf,
	 op_iorwf,
	 op_movf,
	 op_comf,
	 op_incf,
	 op_rrf,
	 op_rlf,

	 op_iorlw,
	 op_andlw,
	 op_xorlw;

   output c_write,
	  z_write;
   

   assign z_write = (op_clrw == 1 ||
		     op_clrf == 1 ||
		     op_subwf == 1 ||
		     op_decf == 1 ||
			       
		     op_andwf == 1 ||
		     op_xorwf == 1 ||
		     op_addwf == 1 ||
		     op_iorwf == 1 ||
		     op_movf == 1 ||
		     op_comf == 1 ||
		     op_incf == 1 ||

		     op_iorlw == 1 ||
		     op_andlw == 1 ||
		     op_xorlw == 1) ? 1:0;
   assign c_write = (op_subwf == 1 ||
		     op_addwf == 1 ||
		     op_rrf == 1 ||
		     op_rlf == 1)  ? 1:0;

endmodule // mux_status_write

   
   



