/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */
module reg_io(clk, 
	      reset,

	      fwe,
	      fsel,

	      fin,

	      tmr0,
	      portA,
	      portB,
	      portC);
   input clk,
	 reset,
	 fwe;

   input [4:0] fsel;
   input [7:0] fin;

   output [7:0] tmr0;
   output [7:0] portA, portB, portC;

   reg [7:0] 	tmr0, portA, portB, portC;
   
   always @(posedge clk or posedge reset) begin
      if(reset == 1) begin
	 tmr0 <= 8'b0000_0000;
	 portA <= 8'b0000_0000;
	 portB <= 8'b0000_0000;
	 portC <= 8'b0000_0000;
      end
      else begin
	 if(fwe == 1) begin
	    case (fsel)
	      5'b00001:
		tmr0 <= fin;
	      5'b00101:
		portA <= fin;
	      5'b00110:
		portB <= fin;
	      5'b00111:
		portC <= fin;
	    endcase // case(fsel)
	 end
      end
   end

endmodule // reg_io

   