/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */

module reg_mux_w(alu_out,
		 wout,
		 d,
		 op_clrw,
		 op_retlw,
		 op_movlw,
		 op_iorlw,
		 op_andlw,
		 op_subwf,
		 op_decf,
		 op_iorwf,
		 op_andwf,
		 op_movf,
		 op_comf,
		 op_incf,
		 op_decsfz,
		 op_rrf,
		 op_rlf,
		 op_swapf,
		 op_incfsz,
		 op_xorwf,
		 op_addwf,
		 op_xorlw,
		 w);

   input [7:0] alu_out,
	       wout;
   input       d;
   input       op_clrw,
	       op_retlw,
	       op_movlw,
	       op_iorlw,
	       op_andlw,
	       op_subwf,
	       op_decf,
	       op_iorwf,
	       op_andwf,
	       op_movf,
	       op_comf,
	       op_incf,
	       op_decsfz,
	       op_rrf,
	       op_rlf,
	       op_swapf,
	       op_incfsz,
	       op_xorwf,
	       op_addwf,
	       op_xorlw;
   

   output [7:0] w;
   

   assign w =  
	  ((op_clrw == 1 ||
	    op_retlw == 1||
	    op_movlw == 1||
	    op_iorlw == 1||
	    op_andlw == 1) ||
	   (op_subwf == 1 ||
	    op_decf == 1 ||
	    op_iorwf == 1 ||
	    op_andwf == 1 ||
	    op_movf == 1 ||
	    op_comf == 1 ||
	    op_incf == 1 ||
	    op_decsfz == 1||
	    op_rrf == 1 ||
	    op_rlf == 1 ||
	    op_swapf == 1 ||
	    op_xorwf == 1 ||
	    op_addwf == 1 ||
	    op_xorlw == 1 ||
	    op_incfsz == 1) && d==0) ? alu_out : wout;
endmodule	 
